// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataplex/v1/content.proto

#include "google/cloud/dataplex/content_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataplex {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ContentServiceConnectionIdempotencyPolicy::
    ~ContentServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultContentServiceConnectionIdempotencyPolicy
    : public ContentServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultContentServiceConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ContentServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultContentServiceConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency CreateContent(
      google::cloud::dataplex::v1::CreateContentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateContent(
      google::cloud::dataplex::v1::UpdateContentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteContent(
      google::cloud::dataplex::v1::DeleteContentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetContent(
      google::cloud::dataplex::v1::GetContentRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListContent(
      google::cloud::dataplex::v1::ListContentRequest) override {
    return Idempotency::kIdempotent;
  }
};
}  // namespace

std::unique_ptr<ContentServiceConnectionIdempotencyPolicy>
MakeDefaultContentServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultContentServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataplex
}  // namespace cloud
}  // namespace google
