// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataproc/v1/workflow_templates.proto

#include "google/cloud/dataproc/workflow_template_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dataproc {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

WorkflowTemplateServiceConnectionIdempotencyPolicy::
    ~WorkflowTemplateServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultWorkflowTemplateServiceConnectionIdempotencyPolicy
    : public WorkflowTemplateServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultWorkflowTemplateServiceConnectionIdempotencyPolicy() override =
      default;

  /// Create a new copy of this object.
  std::unique_ptr<WorkflowTemplateServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultWorkflowTemplateServiceConnectionIdempotencyPolicy>(*this);
  }

  Idempotency CreateWorkflowTemplate(
      google::cloud::dataproc::v1::CreateWorkflowTemplateRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetWorkflowTemplate(
      google::cloud::dataproc::v1::GetWorkflowTemplateRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency InstantiateWorkflowTemplate(
      google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency InstantiateInlineWorkflowTemplate(
      google::cloud::dataproc::v1::
          InstantiateInlineWorkflowTemplateRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateWorkflowTemplate(
      google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest const&)
      override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListWorkflowTemplates(
      google::cloud::dataproc::v1::ListWorkflowTemplatesRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency DeleteWorkflowTemplate(
      google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<WorkflowTemplateServiceConnectionIdempotencyPolicy>
MakeDefaultWorkflowTemplateServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultWorkflowTemplateServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataproc
}  // namespace cloud
}  // namespace google
