// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/experiment.proto

#include "google/cloud/dialogflow_cx/experiments_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_cx {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ExperimentsConnectionIdempotencyPolicy::
    ~ExperimentsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultExperimentsConnectionIdempotencyPolicy
    : public ExperimentsConnectionIdempotencyPolicy {
 public:
  ~DefaultExperimentsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ExperimentsConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultExperimentsConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency ListExperiments(
      google::cloud::dialogflow::cx::v3::ListExperimentsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetExperiment(
      google::cloud::dialogflow::cx::v3::GetExperimentRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateExperiment(
      google::cloud::dialogflow::cx::v3::CreateExperimentRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateExperiment(
      google::cloud::dialogflow::cx::v3::UpdateExperimentRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteExperiment(
      google::cloud::dialogflow::cx::v3::DeleteExperimentRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency StartExperiment(
      google::cloud::dialogflow::cx::v3::StartExperimentRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency StopExperiment(
      google::cloud::dialogflow::cx::v3::StopExperimentRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ExperimentsConnectionIdempotencyPolicy>
MakeDefaultExperimentsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultExperimentsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx
}  // namespace cloud
}  // namespace google
