// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/agent.proto

#include "google/cloud/dialogflow_es/agents_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

AgentsConnectionIdempotencyPolicy::~AgentsConnectionIdempotencyPolicy() =
    default;

namespace {
class DefaultAgentsConnectionIdempotencyPolicy
    : public AgentsConnectionIdempotencyPolicy {
 public:
  ~DefaultAgentsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<AgentsConnectionIdempotencyPolicy> clone() const override {
    return absl::make_unique<DefaultAgentsConnectionIdempotencyPolicy>(*this);
  }

  Idempotency GetAgent(
      google::cloud::dialogflow::v2::GetAgentRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency SetAgent(
      google::cloud::dialogflow::v2::SetAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteAgent(
      google::cloud::dialogflow::v2::DeleteAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency SearchAgents(
      google::cloud::dialogflow::v2::SearchAgentsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency TrainAgent(
      google::cloud::dialogflow::v2::TrainAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ExportAgent(
      google::cloud::dialogflow::v2::ExportAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ImportAgent(
      google::cloud::dialogflow::v2::ImportAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency RestoreAgent(
      google::cloud::dialogflow::v2::RestoreAgentRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency GetValidationResult(
      google::cloud::dialogflow::v2::GetValidationResultRequest const&)
      override {
    return Idempotency::kIdempotent;
  }
};
}  // namespace

std::unique_ptr<AgentsConnectionIdempotencyPolicy>
MakeDefaultAgentsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultAgentsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
