// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/conversation.proto

#include "google/cloud/dialogflow_es/conversations_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ConversationsConnectionIdempotencyPolicy::
    ~ConversationsConnectionIdempotencyPolicy() = default;

namespace {
class DefaultConversationsConnectionIdempotencyPolicy
    : public ConversationsConnectionIdempotencyPolicy {
 public:
  ~DefaultConversationsConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ConversationsConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultConversationsConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency CreateConversation(
      google::cloud::dialogflow::v2::CreateConversationRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ListConversations(
      google::cloud::dialogflow::v2::ListConversationsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetConversation(
      google::cloud::dialogflow::v2::GetConversationRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CompleteConversation(
      google::cloud::dialogflow::v2::CompleteConversationRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency ListMessages(
      google::cloud::dialogflow::v2::ListMessagesRequest) override {
    return Idempotency::kIdempotent;
  }
};
}  // namespace

std::unique_ptr<ConversationsConnectionIdempotencyPolicy>
MakeDefaultConversationsConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultConversationsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
