// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/entity_type.proto

#include "google/cloud/dialogflow_es/entity_types_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

EntityTypesConnectionIdempotencyPolicy::
    ~EntityTypesConnectionIdempotencyPolicy() = default;

namespace {
class DefaultEntityTypesConnectionIdempotencyPolicy
    : public EntityTypesConnectionIdempotencyPolicy {
 public:
  ~DefaultEntityTypesConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<EntityTypesConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultEntityTypesConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency ListEntityTypes(
      google::cloud::dialogflow::v2::ListEntityTypesRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetEntityType(
      google::cloud::dialogflow::v2::GetEntityTypeRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency CreateEntityType(
      google::cloud::dialogflow::v2::CreateEntityTypeRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency UpdateEntityType(
      google::cloud::dialogflow::v2::UpdateEntityTypeRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteEntityType(
      google::cloud::dialogflow::v2::DeleteEntityTypeRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency BatchUpdateEntityTypes(
      google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency BatchDeleteEntityTypes(
      google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency BatchCreateEntities(
      google::cloud::dialogflow::v2::BatchCreateEntitiesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency BatchUpdateEntities(
      google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency BatchDeleteEntities(
      google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<EntityTypesConnectionIdempotencyPolicy>
MakeDefaultEntityTypesConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultEntityTypesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google
