// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/intent.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTENTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTENTS_CONNECTION_H

#include "google/cloud/dialogflow_es/intents_connection_idempotency_policy.h"
#include "google/cloud/dialogflow_es/internal/intents_retry_traits.h"
#include "google/cloud/dialogflow_es/internal/intents_stub.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using IntentsRetryPolicy = ::google::cloud::internal::TraitBasedRetryPolicy<
    dialogflow_es_internal::IntentsRetryTraits>;

using IntentsLimitedTimeRetryPolicy =
    ::google::cloud::internal::LimitedTimeRetryPolicy<
        dialogflow_es_internal::IntentsRetryTraits>;

using IntentsLimitedErrorCountRetryPolicy =
    ::google::cloud::internal::LimitedErrorCountRetryPolicy<
        dialogflow_es_internal::IntentsRetryTraits>;

/**
 * The `IntentsConnection` object for `IntentsClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `IntentsClient`. This allows users to inject custom behavior
 * (e.g., with a Google Mock object) when writing tests that use objects of type
 * `IntentsClient`.
 *
 * To create a concrete instance, see `MakeIntentsConnection()`.
 *
 * For mocking, see `dialogflow_es_mocks::MockIntentsConnection`.
 */
class IntentsConnection {
 public:
  virtual ~IntentsConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual StreamRange<google::cloud::dialogflow::v2::Intent> ListIntents(
      google::cloud::dialogflow::v2::ListIntentsRequest request);

  virtual StatusOr<google::cloud::dialogflow::v2::Intent> GetIntent(
      google::cloud::dialogflow::v2::GetIntentRequest const& request);

  virtual StatusOr<google::cloud::dialogflow::v2::Intent> CreateIntent(
      google::cloud::dialogflow::v2::CreateIntentRequest const& request);

  virtual StatusOr<google::cloud::dialogflow::v2::Intent> UpdateIntent(
      google::cloud::dialogflow::v2::UpdateIntentRequest const& request);

  virtual Status DeleteIntent(
      google::cloud::dialogflow::v2::DeleteIntentRequest const& request);

  virtual future<
      StatusOr<google::cloud::dialogflow::v2::BatchUpdateIntentsResponse>>
  BatchUpdateIntents(
      google::cloud::dialogflow::v2::BatchUpdateIntentsRequest const& request);

  virtual future<StatusOr<google::protobuf::Struct>> BatchDeleteIntents(
      google::cloud::dialogflow::v2::BatchDeleteIntentsRequest const& request);
};

/**
 * A factory function to construct an object of type `IntentsConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of IntentsClient,
 * and that class used instead.
 *
 * The optional @p opts argument may be used to configure aspects of the
 * returned `IntentsConnection`. Expected options are any of the types in
 * the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::dialogflow_es::IntentsPolicyOptionList`
 *
 * @note Unrecognized options will be ignored. To debug issues with options set
 *     `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment and unexpected
 *     options will be logged.
 *
 * @param options (optional) Configure the `IntentsConnection` created by
 * this function.
 */
std::shared_ptr<IntentsConnection> MakeIntentsConnection(Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google

namespace google {
namespace cloud {
namespace dialogflow_es_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

std::shared_ptr<dialogflow_es::IntentsConnection> MakeIntentsConnection(
    std::shared_ptr<IntentsStub> stub, Options options);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_INTENTS_CONNECTION_H
