// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/resourcesettings/v1/resource_settings.proto

#include "google/cloud/resourcesettings/resource_settings_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace resourcesettings {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ResourceSettingsServiceConnectionIdempotencyPolicy::
    ~ResourceSettingsServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultResourceSettingsServiceConnectionIdempotencyPolicy
    : public ResourceSettingsServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultResourceSettingsServiceConnectionIdempotencyPolicy() override =
      default;

  /// Create a new copy of this object.
  std::unique_ptr<ResourceSettingsServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultResourceSettingsServiceConnectionIdempotencyPolicy>(*this);
  }

  Idempotency ListSettings(
      google::cloud::resourcesettings::v1::ListSettingsRequest) override {
    return Idempotency::kIdempotent;
  }

  Idempotency GetSetting(
      google::cloud::resourcesettings::v1::GetSettingRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency UpdateSetting(
      google::cloud::resourcesettings::v1::UpdateSettingRequest const&)
      override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ResourceSettingsServiceConnectionIdempotencyPolicy>
MakeDefaultResourceSettingsServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultResourceSettingsServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace resourcesettings
}  // namespace cloud
}  // namespace google
